﻿define([
    "dojo/_base/declare",
    "dijit/Destroyable"
], function (
    declare,
    Destroyable
) {

    return declare([Destroyable], {
        // summary:
        //      Adjust dialog position in case of small browser window
        // tags:
        //      internal

        _resizeObserver: null,

        destroy: function () {
            this.cleanup();

            this.inherited(arguments);
        },

        adjustDialogPosition: function (dialog) {
            if (this._resizeObserver) {
                this._resizeObserver.disconnect();
            }
            this._resizeObserver = new ResizeObserver(function () {
                if (!dialog.domNode) {
                    return;
                }
                var dialogSize = dialog.domNode.getBoundingClientRect();
                if (dialogSize.top + dialogSize.height > window.innerHeight) {
                    dialog.domNode.style.top = Math.round(window.innerHeight - dialogSize.height - 10) + "px";
                }
            });
            this._resizeObserver.observe(dialog.domNode);
        },

        cleanup: function () {
            if (this._resizeObserver) {
                this._resizeObserver.disconnect();
                this._resizeObserver = null;
            }
        }
    });
});
